import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * Write a description of class Bee here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bee extends Avatar
{
    private boolean doFire = false;
    private int count =0;
    private int count_fire =0;
    private int x_f;
    private int y_f;
    int FIRE_LEVEL = 70;
    private Bullet myBullet = null;
    public Bee ()
        {
        super(1,1);
        }

    public void fireBullet(int x, int y)
        {
          myBullet = new Bullet(Bug.class, 1);
          World w = getWorld();
          w.addObject(myBullet, getX(), getY());
          myBullet.x_t = x;
          myBullet.y_t = y;
          myBullet.setAvatarMovement(myBullet.x_t, myBullet.y_t );
          doFire = false;
        }

    void setNewDestination()
        {
        x_t = Greenfoot.getRandomNumber( getWorld().getWidth() );
        y_t = Greenfoot.getRandomNumber( getWorld().getHeight() );
        setAvatarMovement(x_t, y_t);
        }

    void invertDirection()
        { 
        setAvatarMovement(2*getX()-x_t, 2*getY()-y_t);
        }

    public Vector isBugInRange(int range)
        {
        int x,y;
        List bugs = getNeighbours(range, true, Bug.class);
        if (bugs.isEmpty()) {
            return null;
        }
        else {
            Bug bug = (Bug) bugs.get(0);
            x = bug.getX();
            y = bug.getY();
            Vector v = new Vector((double)x,(double)y);
            return v;
            }
        }

    public void act() 
    {
        if(isDieing())  
            {
            die();
            return;
            }
        Vector v = isBugInRange(250);

        if (doFire)
            {
            fireBullet(x_f,y_f);
            count_fire = 0;
            }
        else if( isAvatarToRotate() )
            rotateAvatar(); 
        else if(isStopAvatarNow(x_t, y_t))
            {
            stop();
            x_s=0;y_s=0;
            setNewDestination();
            }
        else 
            {
            move();
            if( ( x_s != 0) && (y_s != 0) )
                {   
                if(isStopAvatarNow(x_s, y_s))
                    {
                    setAvatarMovement(x_t, y_t);
                    x_s=0;y_s=0;
                    }
                }
            else if (isOutOfWorld())
                    {
                    setNewDestination();
                    }
            else if( 
                            (isObstacle( Butterfly.class)) 
                                    ||
                            (isObstacle( Bee.class))
                                    ||
                            (isObstacle( Bug.class))
                       )
                    {
                    //stop();
                    if(count > 5)
                        {
                        invertDirection();
                        count = 0;
                        }
                    }
            else if( ( v != null) && (count_fire > FIRE_LEVEL) )
                {
                setRotationAngle(v.getX(), v.getY());
                x_f = (int)v.getX();
                y_f = (int)v.getY();
                doFire = true;
                }
            else
                {
                count++;// per un po' di loop devo essermi mosso liberamente
                count_fire++;
                }
            }// else move

        if(isObstacle( Bullet.class))
            {
            Actor actor = getOneIntersectingObject( Bullet.class)  ;
            if( (actor != null) && (myBullet != actor) )
                {
                World w = getWorld();
                w.removeObject(actor);
                die();
                }
            }
    }    
}
