import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * Write a description of class Butterfly here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Butterfly extends Avatar
{
    private int count =0;
    private boolean followMode = false;
    private  MyWorld w;

    public Butterfly ()
        {
        super(1,1);
        MyWorld w = (MyWorld)getWorld();
        }

    public void drawAttackHerePointer(int x, int y)
        {
          OkHere myPointer = new OkHere();
          MyWorld w = (MyWorld)getWorld();
          w.addObject(myPointer, x, y);
        }

    void setNewDestination()
        {
        x_t = Greenfoot.getRandomNumber( getWorld().getWidth() );
        y_t = Greenfoot.getRandomNumber( getWorld().getHeight() );
        setAvatarMovement(x_t, y_t);
        }

    void invertDirection()
        { 
        setAvatarMovement(2*getX()-x_t, 2*getY()-y_t);
        }

    public Vector isBugInRange(int range)
        {
        int x,y;
        List bugs = getNeighbours(range, true, Bug.class);
        if (bugs.isEmpty()) {
            return null;
        }
        else {
            Bug bug = (Bug) bugs.get(0);
            x = bug.getX();
            y = bug.getY();
            Vector v = new Vector((double)x,(double)y);
            return v;
            }
        }

    public void act() 
    {
        MyWorld w = (MyWorld)getWorld();
        if(isDieing())  
            {
            die();
            return;
            }

        if(followMode== true)
            {
              if(Greenfoot.mouseClicked(null))
                    {
                    MouseInfo m_info =  Greenfoot.getMouseInfo();
                    if( 1 == m_info. getButton())
                        {
                          x_t = m_info.getX();
                          y_t = m_info.getY();
                          setAvatarMovement(x_t, y_t);
                          x_s=0;y_s=0;
                          //drawMoveHerePointer((int) x_t,(int) y_t );
                        }
                    }
            }

        if( isAvatarToRotate() )
            rotateAvatar(); 
        else if(isStopAvatarNow(x_t, y_t))
            {
            stop();
            x_s=0;y_s=0;
            Vector v = isBugInRange(350);
            if(null == v)
                setNewDestination();
            else
                {
                x_t = v.getX();
                y_t = v.getY();
                setAvatarMovement( x_t, y_t );
                }
            }
        else 
            {
            move();
            if( ( x_s != 0) && (y_s != 0) )
                {   
                if(isStopAvatarNow(x_s, y_s))
                    {
                    setAvatarMovement(x_t, y_t);
                    x_s=0;y_s=0;
                    }
                }
            else if (isOutOfWorld())
                    {
                    setNewDestination();
                    }
            else if( 
                            /*(isObstacle( Butterfly.class)) 
                                    ||
                            (isObstacle( Bee.class))
                                    ||*/
                            (isObstacle( Bug.class))
                                    &&
                             (followMode == false)
                       )
                    {
                    stop();
                    /*if(count > 5)
                        {
                        invertDirection();
                        count = 0;
                        }*/
                   // MyWorld wrd = (MyWorld)getWorld();
                    if (w.followMode == false)
                        {
                        followMode = true;
                        w.followMode = true;
                        setImage("butterfly4.png");
                        }
                    }
            else
                {
                count++;// per un po' di loop devo essermi mosso liberamente
                }
            }// else move

        if(isObstacle( Bullet.class))
            {
            Actor actor = getOneIntersectingObject( Bullet.class)  ;
            if( (actor != null) )
                {
               w.followMode = false;
               // World w = getWorld();
                w.removeObject(actor);
                die();
                return;
                }
            }

        if(isObstacle( Bee.class))
            {
            w.followMode = false;
            die();
            return;
            }

        if(isObstacle( Flower.class))
            {
            w.followMode = false;
            w.incButterFliesCounter();
            drawAttackHerePointer(getX(), getY());
            (getWorld()).removeObject(this);
            }
    }   
}
