import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Bug here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */

public class Bug extends Avatar
{
    private boolean doFire = false;
    private int x_f;
    private int y_f;
    private Bullet myBullet = null;
    private int count_fire =0;
    int FIRE_LEVEL = 40;
   public Bug()
    {
    super(4,4);
    }

    public void drawMoveHerePointer(int x, int y)
        {
          MoveHere myPointer = new MoveHere();
          World w = getWorld();
          w.addObject(myPointer, x, y);
        }

    public void drawAttackHerePointer(int x, int y)
        {
          AttackHere myPointer = new AttackHere();
          World w = getWorld();
          w.addObject(myPointer, x, y);
        }

    public void fireBullet(int x, int y)
        {
          myBullet = new Bullet(Bee.class, 4);
          World w = getWorld();
          w.addObject(myBullet, getX(), getY());
          myBullet.x_t = x;
          myBullet.y_t = y;
          myBullet.setAvatarMovement(myBullet.x_t, myBullet.y_t );
          doFire = false;
        }

    public void act() 
    {        
        if(isDieing())  
            {
            die();
            return;
            }

        if(Greenfoot.mouseClicked(null))
            {
            MouseInfo m_info =  Greenfoot.getMouseInfo();
            //myLabel3.setText("button " + m_info. getButton() );
            if( 1 == m_info. getButton())
                {
                  x_t = m_info.getX();
                  y_t = m_info.getY();
                  setAvatarMovement(x_t, y_t);
                  x_s=0;y_s=0;
                  drawMoveHerePointer((int) x_t,(int) y_t );
                }
            if( 3 == m_info. getButton())
                {
                  stop();
                  if ( (!doFire) && (count_fire > FIRE_LEVEL) ) 
                    {
                      doFire = true;
                      x_f = m_info.getX();
                      y_f = m_info.getY();
                      setRotationAngle((double)x_f, (double)y_f);
                      drawAttackHerePointer(x_f, y_f);
                    }
                }
            }   
        if( isAvatarToRotate() )
            rotateAvatar();
        else if (doFire)
            {
            fireBullet(x_f,y_f);
            count_fire = 0;
            }
        else if(isStopAvatarNow(x_t, y_t))
            {
            stop();
            x_s=0;y_s=0;
            }
        else 
            {
            move();
            if( ( x_s != 0) && (y_s != 0) )
                {
                if(isStopAvatarNow(x_s, y_s))
                    {
                    setAvatarMovement(x_t, y_t);
                    x_s=0;y_s=0;
                    }
            }
        if(isObstacle( Bullet.class))
            {
            Actor actor = getOneIntersectingObject( Bullet.class)  ;
            if ( (actor != null) && (actor != myBullet ))
                {
                World w = getWorld();
                w.removeObject(actor);
                die();
                }
            }
        }
    count_fire ++;
    }
}
